-- General utility routines used by ecwr 1.50
--
-- Public Domain -- 2007, September 26
-- by Juergen Luethje <support {AT} luethje {DOT} eu>
-- Standard disclaimer: Use at your own risk!

include get.e

global constant
   FALSE = 0, TRUE = 1

global type boolean (object x)
   if integer(x) then
      return x = FALSE or x = TRUE
   end if
   return FALSE
end type

global type string (object x)
   -- sequence of byte
   object t

   if atom(x) then
      return FALSE
   end if
   for i = 1 to length(x) do
      t = x[i]
      if (not integer(t)) or (t < 0)  or (t > #FF) then
         return FALSE
      end if
   end for
   return TRUE
end type

global function iif (boolean condition, object t, object f)
   if condition then
      return t
   else
      return f
   end if
end function

global procedure wait (string msg)
   puts(2, msg & "\n\nPress any key ...")
   if wait_key() then end if
end procedure

global function rextract (sequence source, object x)
   for i = length(source) to 1 by -1 do
      if equal(source[i], x) then
         return source[1..i-1]
      end if
   end for
   return source
end function

global function escape (string source, integer chr)
   sequence ret

   ret = ""
   for i = 1 to length(source) do
      if source[i] = chr then
         ret &= '\\'
      end if
      ret &= source[i]
   end for
   return ret
end function

global function insert_after (string file, integer lineNo, string newText)
   -- lineNo:  0: insert 'newText' before first line
   --         -1: insert 'newText' after last line
   --         -2: insert 'newText' after line before last
   ---        etc.
   object line
   sequence text
   integer fn

   -- read file
   fn = open(file, "r")
   if fn = -1 then
      return -1             -- error
   end if

   text = {}
   line = gets(fn)
   while sequence(line) do
      text = append(text, line)
      line = gets(fn)
   end while
   close(fn)

   -- handle special cases for lineNo
   if lineNo < 0 then
      lineNo += (length(text)+1)
      if lineNo < 0 then
         lineNo = 0
      end if
   elsif lineNo > length(text) then
      lineNo = length(text)
   end if

   -- write file
   fn = open(file, "w")
   if fn = -1 then
      return -1             -- error
   end if

   for i = 1 to lineNo do
      puts(fn, text[i])
   end for
   puts(fn, newText)
   for i = lineNo+1 to length(text) do
      puts(fn, text[i])
   end for
   close(fn)

   return 0
end function
